* Program ...: Arry.PRG
* Author ....: Richard Biegel
* Date ......: October 9, 1989
* Versions ..: dBASE IV 1.0 and 1.1
* Note(s) ...: This program is a demonstration of two dimensional arrays
*              that have been "expanded" into an extra pseudo-dimension.
*              These arrays behave as if they are three-dimensional and can
*              be used as such.

SET BELL OFF
SET BORDER TO DOUBLE
SET ESCAPE OFF
SET SCOREBOARD OFF
SET STATUS OFF
SET TALK OFF

DEFINE MENU MArray                                          && Main Menu
DEFINE PAD pDimensn OF MArray;                              
       PROMPT " 3-DIMENSIONAL ARRAYS  " AT 6, 27
ON PAD pDimensn OF MArray ACTIVATE POPUP PopArray

DEFINE POPUP PopArray FROM 7, 27 MESSAGE;
       "Examine some 3-D array creation options."
DEFINE BAR 1 OF PopArray PROMPT " Array of CHARACTER(S) "   && 3-D Char Array
DEFINE BAR 2 OF PopArray PROMPT " Array of NUMERICS     "   && 3-D Num Array
DEFINE BAR 3 OF PopArray PROMPT " Array of DATES        "   && 3-D Date Array
DEFINE BAR 4 OF PopArray PROMPT " Array of LOGICAL      "   && 3-D Logic Array
DEFINE BAR 5 OF PopArray PROMPT " Quit and Exit         "    

ON SELECTION POPUP PopArray DO Trap WITH BAR()

DEFINE MENU xChoice    && Horizontal menu on bottom of screen 
DEFINE PAD MakeArry OF xChoice PROMPT "Create New Array" AT 23, 2 
DEFINE PAD ShowArry OF xChoice PROMPT "Display Array" AT 23, 22
DEFINE PAD FillArry OF xChoice PROMPT "Enter Array Values" AT 23, 40
DEFINE PAD GetOut   OF xChoice PROMPT "Quit and Exit" AT 23, 62

ON SELECTION PAD MakeArry OF xChoice DO xTrap WITH "SPEC"   && Create Array
ON SELECTION PAD ShowArry OF xChoice DO xTrap WITH "LIST"   && Display Array
ON SELECTION PAD FillArry OF xChoice DO xTrap WITH "ALTER"  && Enter Elements
ON SELECTION PAD GetOut   OF xChoice DO xTrap WITH "LEAVE"  && Quit and Exit

mBar = 0                             &&  Which popup bar is chosen?
STORE SPACE(1) TO mCharX, mNumX,;
		  mDateX, mLogicX    &&  Dimension template strings.

STORE 1 TO mRow, mCol, mUp           &&  Length of array dimensions.
				     && Both mRow and mCol are real dimensions,
				     &&  while mUp is a pseudo-dimension.
				     
DO WHILE .T.       && Begin MAIN CONTROL LOOP.

	CLEAR
	@ 1, 19 TO 3, 59 DOUBLE
	@ 2, 21 SAY "ARRAY EXPANSION DEMONSTRATION PROGRAM"
	ACTIVATE MENU mArray 
	DO CASE
		CASE mBar = 1                  &&  Create a 3-D CHARACTER array.
			mChoose1 = "SPEC"         &&  SPEC means "specify" the attributes.
			DO WHILE .T.
				DO CASE
					CASE mChoose1 = "SPEC"                   
						DO ArrySpec WITH mRow, mCol, mUp       && Describe array.
						DO TypeSpec WITH "CHAR", mCharX, mUp   && Describe content.
						DECLARE SAMPLE[mRow, mCol]             && Create array.
						DO ArryFill WITH mRow, mCol, mCharX    && Fill with blanks.

					CASE mChoose1 = "ALTER"
						DO ArryAlt  WITH mRow, mCol, mUp,;    
						mCharX, "CHAR"        && Input elements.

					CASE mChoose1 = "LIST" 
					   DO ArryList WITH mRow, mCol, mUp,;
						mCharX                && Show array in layered format.

					OTHERWISE
						EXIT
				ENDCASE
				@ 22, 0 CLEAR TO 24,79
				ACTIVATE MENU xChoice PAD ShowArry
			ENDDO

		CASE mBar = 2                &&  Create a 3-D NUMERIC array.
			mChoose1 = "SPEC"         &&  SPEC means "specify" the attributes.
			DO WHILE .T.
				DO CASE
					CASE mChoose1 = "SPEC"
						DO ArrySpec WITH mRow, mCol, mUp       && Describe array.
						DO TypeSpec WITH "NUM", mNumX, mUp     && Describe content.
						DECLARE SAMPLE[mRow, mCol]             && Create array.
						DO ArryFill WITH mRow, mCol, mNumX     && Fill with blanks.

					CASE mChoose1 = "ALTER"
						DO ArryAlt  WITH mRow, mCol, mUp,;
						mNumX, "NUM"          && Input elements.

					CASE mChoose1 = "LIST" 
						DO ArryList WITH mRow, mCol, mUp,;
						mNumX                 && Show array in layered format.

					OTHERWISE

						EXIT
				ENDCASE
				@ 22, 0 CLEAR TO 24,79
				ACTIVATE MENU xChoice PAD ShowArry
			ENDDO

		CASE mBar = 3                &&  Create a 3-d DATE array.
			mChoose1 = "SPEC"         &&  SPEC means "specify" the attributes.
			DO WHILE .T.
				DO CASE
					CASE mChoose1 = "SPEC"
						DO ArrySpec WITH mRow, mCol, mUp       && Describe array.
						DO TypeSpec WITH "DATE", mDateX, mUp   && Describe content.
						DECLARE SAMPLE[mRow, mCol]             && Create array.
						DO ArryFill WITH mRow, mCol, mDateX    && Fill with blanks.

					CASE mChoose1 = "ALTER"
						DO ArryAlt  WITH mRow, mCol, mUp,;
						mDateX, "DATE"        && Input elements.

					CASE mChoose1 = "LIST" 
						DO ArryList WITH mRow, mCol, mUp,;
						mDateX                && Show array in layered format.

					OTHERWISE
						EXIT
				ENDCASE
				@ 22, 0 CLEAR TO 24,79
				ACTIVATE MENU xChoice PAD ShowArry
			ENDDO

		CASE mBar = 4                &&  Create a 3-D Logic array.
			mChoose1 = "SPEC"         &&  SPEC means "specify" the attributes.
			DO WHILE .T.
				DO CASE
					CASE mChoose1 = "SPEC"
						DO ArrySpec WITH mRow, mCol, mUp       && Describe array.
						DO TypeSpec WITH "LOGIC", mLogicX, mUp && Describe content.
						DECLARE SAMPLE[mRow, mCol]             && Create array.
						DO ArryFill WITH mRow, mCol, mLogicX   && Fill with blanks.

					CASE mChoose1 = "ALTER"
						DO ArryAlt  WITH mRow, mCol, mUp,;
						mLogicX, "LOGIC"      && Insert elements.

					CASE mChoose1 = "LIST" 
						DO ArryList WITH mRow, mCol, mUp,;
						mLogicX             && Show array in layered format.
 
					OTHERWISE
						EXIT
				ENDCASE
				@ 22, 0 CLEAR TO 24,79
				ACTIVATE MENU xChoice PAD ShowArry
			ENDDO

		CASE mBar = 5                  &&  That's all, folks!
			CLEAR ALL
			CLEAR
			RETURN
	ENDCASE 
ENDDO              &&  End MAIN CONTROL LOOP.


***********************
*      PROCEDURES     *
***********************

PROCEDURE Trap
	PARAMETER pBar
	mBar = pBar                       && Trapping procedure for the main menu.
	CLEAR
	DEACTIVATE MENU
RETURN


PROCEDURE XTrap
	PARAMETER pChoice
	STORE pChoice TO mChoose1         && Trapping procedure for the continuation
	DEACTIVATE MENU                   && menu.
RETURN


PROCEDURE ArrySpec
	PARAMETERS pRow, pCol, pUp
	CLEAR

	SET CONFIRM ON
	@ 3, 5 TO 8, 36 DOUBLE
	@ 4, 7 SAY "Enter the number of ROWS in"
	@ 5, 7 SAY "the array.  For the sake of"
	@ 6, 7 SAY "brevity, enter a number less"
	@ 7, 7 SAY "than or equal to EIGHT (8)" GET pRow PICTURE "9";
       VALID (pRow > 0) .AND. (pRow <= 8)  
	READ

	@ 3, 39 TO 7, 74 DOUBLE
	@ 4, 41 SAY "Enter the number of COLUMNS in"
	@ 5, 41 SAY "the array.  Enter only a number"
	@ 6, 41 SAY "less than or equal to SIX (6)" GET pCol PICTURE "9";
		VALID (pCol > 0) .AND. (pCol <= 6)
	READ

	@ 10,22 TO 15,56 DOUBLE
	@ 11,24 SAY "Enter the number of LAYERS (or"
	@ 12,24 SAY "PSEUDO-DIMENSION lenth) to make"
	@ 13,24 SAY "the array 3-dimensional.  Make"
	@ 14,28 SAY "it FIVE (5) or less" GET pUp PICTURE "9";
					VALID (pUp > 0) .AND. (pUp <= 5)
	READ
	SET CONFIRM OFF
RETURN


PROCEDURE TypeSpec                        &&  This procedure will create
	PARAMETERS pType, pSpec, pUp         &&  a "template" string to be
	mLong = 1                            &&  inserted into the 2-dimensional
	DO CASE                              &&  array to "up" it to 3-D status.
			CASE pType = "CHAR"
			CLEAR
			@ 7, 20 TO 11,55 DOUBLE
			@ 8, 22 SAY "Enter the lenth of the character"
			@ 9, 22 SAY "strings to put into the array.  "
			@ 10,22 SAY "Make it EIGHT (8) or less" GET mLong;
				PICTURE "99" VALID (mLong > 0) .AND. (mLong <= 8)
			READ
			pSpec = "%1_"+REPLICATE("^", mLong)    && Beginning of "template" string
						                             && from CHARACTER array.
		CASE pType = "NUM"
			CLEAR
			mLong = 4
			@ 6, 20 TO 14,56 DOUBLE
			@ 7, 22 SAY "Enter the overall LENGTH of the"
			@ 8, 22 SAY "numeric field.  Length should"
			@ 9, 22 SAY "include the decimal portion, non-"
			@ 10,22 SAY "decimal portion and even the"
			@ 11,22 SAY "period for the decimal; length"
			@ 12,22 SAY "should not exceed EIGHT (8) and" 
			@ 13,22 SAY "not be less than FOUR (4)" GET mLong;
				PICTURE "99" VALID (mLong >= 4) .AND. (mLong <= 8)
			@ 3, 21 SAY "Example:  This number has a LENGTH"
			@ 4, 21 SAY "       of SIX (6):  452.45"
			READ
			pSpec = "%1_"+REPLICATE("0", mLong - 3);
					+".00"								&& Beginning of "template" 
														&& string for NUMERIC array.
		CASE pType = "DATE"
			@ 17,24 SAY "    Array is now constructed.    "
			@ 18,24 SAY "No need to enter Date Length; all"
			@ 19,24 SAY "dates have a standard length of  "
			@ 20,24 SAY "      EIGHT (8) characters.      "
			mLong = 8
			pSpec = "%1_  /  /  "					        && Beginning of "template"
														 && string for DATE array.
		CASE pType = "LOGIC"
			@ 17,23 SAY "     Array is now constructed.     "
			@ 18,23 SAY "No need to enter Logic Length; all "
			@ 19,23 SAY " logics have a standard length of  "
			@ 20,23 SAY "       THREE (3) characters.       "
			mLong = 3
			pSpec = "%1_.F."							&& Beginning of "template"
														&& string for LOGIC array.
	ENDCASE

	mCounter = 2
	DO WHILE (mCounter <= pUp)          && BEGIN Create Template String.
		DO CASE
			CASE (pType = "CHAR") 
				pSpec = pSpec+"%"+LTRIM(STR(mCounter));
						+"_"+REPLICATE("^", mLong)

			CASE (pType = "NUM")
				pSpec = pSpec+"%"+LTRIM(STR(mCounter))+"_";
						+REPLICATE("0", mLong - 3)+".00" 

			CASE (pType = "DATE")
				pSpec = pSpec+"%"+LTRIM(STR(mCounter))+"_  /  /  "

			CASE (pType = "LOGIC")
				pSpec = pSpec+"%"+LTRIM(STR(mCounter))+"_.F."

		ENDCASE
		mCounter = mCounter + 1  
	ENDDO                               && END Create Template String.

	pSpec = pSpec+"%";
		+LTRIM(STR(mCounter))+"_"   && Put "capper" on the end for reference.
RETURN
*--- End PROCEDURE TypeSpec


PROCEDURE ArryFill                  && Procedure for filling the 2-D array
	PARAMETERS Row, Col, Filler      && with template strings for third dimension.
	RowIndex = 1
	ColIndex = 1
	DO WHILE (RowIndex <= Row)
		DO WHILE (ColIndex <= Col)
			SAMPLE[RowIndex, ColIndex] = Filler
			ColIndex = ColIndex + 1
		ENDDO
		ColIndex = 1
		RowIndex = RowIndex + 1
	ENDDO
RETURN


PROCEDURE ArryAlt
	* Procedure for inserting items at will into the array.
	PARAMETERS pRow, pCol, pUp, Determin, Typex

	Varlen = AT("%", SUBSTR(Determin, 4, 10)) - 1   && Valen = length of individual
	TempVar = SPACE(Varlen)                          && array elements.
	STORE 1 TO xRow, xCol, xUp

	DO WHILE .T.
		CLEAR
   
		* --- BEGIN Guide to user to show dimension limits.
		@ 1, 18 TO 7, 59
		@ 2, 22 SAY "ROW must be less than or equal to "+LTRIM(STR(pRow))
		@ 4, 20 SAY "COLUMN must be less than or equal to "+LTRIM(STR(pCol))
		@ 6, 20 SAY "LAYERS must be less than or equal to "+LTRIM(STR(pUp))
		* --- END Guide to user to show dimension limits.
  
		@ 9, 29 TO 15,47
		@ 10,31 SAY "   Enter ROW:" GET xRow PICTURE "9";
		        VALID (xRow > 0) .AND. (xRow <= pRow)
		@ 12,31 SAY "Enter COLUMN:" GET xCol PICTURE "9";
		        VALID (xCol > 0) .AND. (xCol <= pCol)
		@ 14,31 SAY " Enter LAYER:" GET xUp  PICTURE "9";
		        VALID (xUp > 0) .AND. (xUp <= pUp)
		READ
		DO CASE
			CASE Typex = "CHAR"         && Create CHARACTER value to put in array.
				@ 17,23 SAY "Enter Replacement Value:" GET TempVar
				READ 

			CASE Typex = "NUM"          && Create "NUMERIC" value to put in array.
				VarNum = 0
				xPict = "PICTURE '"+REPLICATE("9", VarLen - 3)+".99'"
				@ 17,23 SAY "Enter Replacement Value:" GET VarNum &xPict
				READ
				TempVar = STR(VarNum, Varlen, 2)

			CASE Typex = "DATE"         && Create "DATE" value to put in array.
				VarDate = CTOD("  /  /  ")
				@ 17,23 SAY "Enter Replacement Value:" GET VarDate
				READ
				TempVar = DTOC(VarDate)

			CASE Typex = "LOGIC"        && Create "LOGIC" value to put in array.
				VarLogic = .T.
				@ 17,25 SAY "Enter Replacement Value:" GET VarLogic
				READ
				TempVar = IIF(VarLogic, .T., .F.)
		ENDCASE
		Ans = " "
		@ 19,27 SAY "Make Replacement Now?" GET Ans VALID (Ans $ "YyNn")
		READ
  
		IF (UPPER(Ans) = "Y")          && BEGIN Make replacement into array.
			xDet = SAMPLE[xRow, xCol]
			cIndex = "%"+LTRIM(STR(xUp))+"_"
			xIndex = "%"+LTRIM(STR(xUp + 1)) 
			Offset = LEN(cIndex)
			xDet = SUBSTR(xDet, 1, AT(cIndex, xDet) + Offset - 1)+TempVar;
					+SUBSTR(xDet, AT(xIndex, xDet), LEN(xDet))
			SAMPLE[xRow, xCol] = xDet
		ENDIF                          && END Make replacement into array.
   
		Ans = " "
		@ 21,32 SAY "Do another?" GET Ans VALID (Ans $ "YyNn")
		READ
		IF (UPPER(Ans) = "N")
			EXIT
		ENDIF 
	ENDDO
RETURN
* --- End PROCEDURE ArryAlt


PROCEDURE ArryList
   * Procedure for showing the new array and its third "dimension" graphically.
	PARAMETERS Row, Col, Up, Determin
	CLEAR
	VarLen = AT("%", SUBSTR(Determin, 4, 10)) - 1
	Adjust = 9 - VarLen

	OffX = 3 + (30 - (Col * 5)) + (10 - (Up * 2))     && Screen coordinate offsets
	OffY = 2 + (16 - (Row * 2)) / 2                   && for changing screen.
	
	XCoord = OffX                                     && Actual screen coordinates
	YCoord = OffY                                     && for data placement.

	xEnd = OffX + (Col * 10) - Adjust                 && Box coordinates for 
	yEnd = OffY + (Row * 2) - 1                       && delineating array levels.

	mDisplay = 1
	DO WHILE (mDisplay <= Up)         && BEGIN travel from layer to layer.
		cIndex = "%"+LTRIM(STR(mDisplay))+"_"
		Offset = LEN(cIndex)
		RowIndex = 1
		ColIndex = 1
		xStart = XCoord - 2
		yStart = YCoord - 1
		@ yStart, xStart TO yEnd, xEnd DOUBLE
  
		* --- BEGIN List out a single layer.
		DO WHILE (RowIndex <= Row)     
			DO WHILE (ColIndex <= Col)
				Holder = SAMPLE[RowIndex, ColIndex]
				@ YCoord, XCoord SAY;
				SUBSTR(Holder, AT(cIndex, Holder) + Offset, VarLen)
				XCoord = XCoord + 10
				ColIndex = ColIndex + 1
			ENDDO
			XCoord = OffX
			YCoord = YCoord + 2
			ColIndex = 1
			RowIndex = RowIndex + 1
		ENDDO   
		* --- END List out a single layer.
   
		Ans = " "
		@ 23, 2 SAY "Next: <Return>, "+CHR(25)+" or 'N'"+SPACE(7);
		           +"Previous: "+CHR(24)+" or 'P'"+SPACE(6);
		           +"Quit: <Esc> or 'Q'" GET Ans VALID (Ans $ " NnQqPp")
		SET BORDER TO SINGLE
		@ 22, 0 TO 24,27 
		@ 22,31 TO 24,51
		@ 22,55 TO 24,78
		SET BORDER TO DOUBLE 
		READ
		IF (READKEY() = 12)
			EXIT
		ENDIF

		Ans = UPPER(Ans)
		DO CASE
			CASE (READKEY() = 5) .OR. (Ans = "N") .OR.;
				((Ans = " ") .AND. (READKEY() <> 4))     && "Up" a Level.
				IF (mDisplay < Up)
					mDisplay = mDisplay + 1               && Travel "up" a level
					OffX = OffX + 4                       && on the template.
					OffY = OffY + 1
					XCoord = OffX
					YCoord = OffY
					xEnd = xEnd + 4
					yEnd = yEnd + 1
					@ YCoord, (XCoord - 1) CLEAR TO yEnd, xEnd
				ELSE
					XCoord = OffX
					YCoord = OffY
				ENDIF

			CASE (Ans = "P") .OR. (READKEY() = 4)       && "Down" a Level.
				IF (mDisplay > 1)
					mDisplay = mDisplay - 1               && Travel "down" a level
					OffX = OffX - 4                       && on the template.
					OffY = OffY - 1                          
					XCoord = OffX
					YCoord = OffY
					xEnd = xEnd - 4
					yEnd = yEnd - 1
					@ YCoord, XCoord CLEAR TO (yEnd + 1), (xEnd + 4)
				ELSE
					XCoord = OffX
					YCoord = OffY
				ENDIF

			OTHERWISE
				EXIT
		ENDCASE
	ENDDO                        && END Travel from layer to layer.
RETURN
*--- End PROCEDURE ArryList

* EoF: Arry.PRG
